<?php
#-----------------------------------------------------#
#          ********* ROTORCMS *********               #
#              Made by  :  VANTUZ                     #
#               E-mail  :  visavi.net@mail.ru         #
#                 Site  :  http://pizdec.ru           #
#             WAP-Site  :  http://visavi.net          #
#                  ICQ  :  36-44-66                   #
#  Вы не имеете право вносить изменения в код скрипта #
#        для его дальнейшего распространения          #
#-----------------------------------------------------#	
require_once ('../includes/start.php');
require_once ('../includes/functions.php');
require_once ('../includes/header.php');
include_once ('../themes/' . $config['themes'] . '/index.php');

if (isset($_GET['fid'])) {
  $fid = abs(intval($_GET['fid']));
} else {
  $fid = 0;
} 
if (isset($_GET['start'])) {
  $start = abs(intval($_GET['start']));
} else {
  $start = 0;
} 
if (isset($_GET['act'])) {
  $act = check($_GET['act']);
} else {
  $act = 'index';
} 

show_title('menu.png', 'Форум ' . $config['title']);

switch ($act):
# ###########################################################################################
# #                                    Главная страница                                    ##
# ###########################################################################################
case "index":
  $queryforum = DB :: $dbh -> query("SELECT * FROM `forums` WHERE `forums_id`=? LIMIT 1;", array($fid));
  $forums = $queryforum -> fetch();

  if (!empty($forums)) {
    $config['newtitle'] = $forums['forums_title'];

    echo '<a href="#down"><img src="../images/img/downs.gif" alt="Вниз" /></a> ';
    echo '<a href="index.php?' . SID . '">Форум</a> / ';

    if (!empty($forums['forums_parent'])) {
      $querysub = DB :: $dbh -> query("SELECT `forums_id`, `forums_title` FROM `forums` WHERE `forums_id`=? LIMIT 1;", array($forums['forums_parent']));
      $sub = $querysub -> fetch();
      echo '<a href="forum.php?fid=' . $sub['forums_id'] . '&amp;' . SID . '">' . $sub['forums_title'] . '</a> / ';
    } 

    echo '<a href="forum.php?fid=' . $fid . '&amp;start=' . $start . '&amp;rand=' . mt_rand(1000, 9999) . '&amp;' . SID . '">Обновить</a> / ';
    echo '<a href="forum.php?act=addtheme&amp;fid=' . $fid . '&amp;' . SID . '">Создать тему</a><br /><br />';

    echo '<img src="../images/img/themes.gif" alt="image" /> <b>' . $forums['forums_title'] . '</b>';

    if (is_admin(array(101, 102, 103, 105))) {
      echo ' (<a href="' . ADMINDIR . 'forum.php?act=forum&amp;fid=' . $fid . '&amp;start=' . $start . '&amp;' . SID . '">Управление</a>)';
    } 
    echo '<hr />';

    $querysub = DB :: $dbh -> query("SELECT * FROM `forums` WHERE `forums_parent`=?;", array($fid));
    $sub = $querysub -> fetchAll();

    if (count($sub) > 0 && $start == 0) {
      foreach($sub as $subdata) {
        echo '<div class="b"><img src="../images/img/forums.gif" alt="image" /> ';
        echo '<b><a href="forum.php?fid=' . $subdata['forums_id'] . '&amp;' . SID . '">' . $subdata['forums_title'] . '</a></b> (' . $subdata['forums_topics'] . '/' . $subdata['forums_posts'] . ')</div>';

        if ($subdata['forums_last_id'] > 0) {
          echo '<div>Тема: <a href="topic.php?act=end&amp;tid=' . $subdata['forums_last_id'] . '&amp;' . SID . '">' . $subdata['forums_last_themes'] . '</a><br />';
          echo 'Сообщение: ' . nickname($subdata['forums_last_user']) . ' (' . date_fixed($subdata['forums_last_time']) . ')</div>';
        } else {
          echo '<div>Темы еще не созданы!</div>';
        } 
      } 
      echo '<hr />';
    } 

    $total = DB :: $dbh -> querySingle("SELECT count(*) FROM `topics` WHERE `topics_forums_id`=?;", array($fid));

    if ($total > 0) {
      if ($start >= $total) {
        $start = 0;
      } 

      $querytopic = DB :: $dbh -> query("SELECT * FROM `topics` WHERE `topics_forums_id`=? ORDER BY `topics_locked` DESC, `topics_last_time` DESC LIMIT " . $start . ", " . $config['forumtem'] . ";", array($fid));

      while ($data = $querytopic -> fetch()) {
        echo '<div class="b">';

        if ($data['topics_locked'] == 1) {
          echo '<img src="../images/img/lock.gif" alt="image" /> ';
        } elseif ($data['topics_closed'] == 1) {
          echo '<img src="../images/img/closed.gif" alt="image" /> ';
        } else {
          echo '<img src="../images/img/topics.gif" alt="image" /> ';
        } 

        echo '<b><a href="topic.php?tid=' . $data['topics_id'] . '&amp;' . SID . '">' . $data['topics_title'] . '</a></b> (' . $data['topics_posts'] . ')</div>';
        echo '<div>Страницы: ';
        forum_navigation('topic.php?tid=' . $data['topics_id'] . '&amp;', $config['forumpost'], $data['topics_posts']);
        echo 'Сообщение: ' . nickname($data['topics_last_user']) . ' (' . date_fixed($data['topics_last_time']) . ')</div>';
      } 

      page_strnavigation('forum.php?fid=' . $fid . '&amp;', $config['forumtem'], $start, $total);

      echo '<a href="#up"><img src="../images/img/ups.gif" alt="up" /></a> ';
      echo '<a href="forum.php?act=addtheme&amp;fid=' . $fid . '&amp;' . SID . '">Создать тему</a> / ';
      echo '<a href="../pages/rules.php?' . SID . '">Правила</a> / ';
      echo '<a href="top.php?act=themes&amp;' . SID . '">Топ тем</a> / ';
      echo '<a href="search.php?fid=' . $fid . '&amp;' . SID . '">Поиск</a><br />';
    } else {
      show_error('Тем еще нет, будь первым!');
    } 
  } else {
    show_error('Ошибка! Данного раздела не существует!');
  } 
  break;
# ###########################################################################################
# #                               Подготовка к созданию темы                               ##
# ###########################################################################################
case "addtheme":

  $config['newtitle'] = 'Создание новой темы';

  if (is_user()) {
    $queryforum = DB :: $dbh -> query("SELECT `forums_id`, `forums_parent`, `forums_title` FROM `forums` ORDER BY `forums_order` ASC;");
    $forums = $queryforum -> fetchAll();

    if (count($forums) > 0) {
      echo '<div class="form" id="form">';
      echo '<form action="forum.php?act=add&amp;fid=' . $fid . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" name="form" method="post">';

      echo 'Раздел:<br />';

      $output = array();

      foreach ($forums as $row) {
        $i = $row['forums_id'];
        $p = $row['forums_parent'];
        $output[$p][$i] = $row;
      } 

      echo '<select name="fid">';

      foreach ($output[0] as $key => $data) {
        $selected = ($fid == $data['forums_id']) ? ' selected="selected"' : '';
        echo '<option value="' . $data['forums_id'] . '"' . $selected . '>' . $data['forums_title'] . '</option>';

        if (isset($output[$key])) {
          foreach($output[$key] as $datasub) {
            $selected = ($fid == $datasub['forums_id']) ? ' selected="selected"' : '';
            echo '<option value="' . $datasub['forums_id'] . '"' . $selected . '>– ' . $datasub['forums_title'] . '</option>';
          } 
        } 
      } 

      echo '</select><br />';

      echo 'Заголовок:<br />';
      echo '<input type="text" name="title" size="50" maxlength="50" /><br />';
      echo 'Сообщение:<br />';
      echo '<textarea cols="25" rows="3" name="msg" id="msg"></textarea><br />';

      if (!empty($udata['users_bbpanel'])) {
        quickpaste('msg');
        quickcode();
        quicksmiles();
      } 

      echo '<input value="Создать тему" type="submit" /></form></div><br />';

      echo 'Прежде чем создать новую тему необходимо ознакомиться с правилами<br />';
      echo '<a href="../pages/rules.php?' . SID . '">Правила сайта</a><br />';
      echo 'Также убедись что такой темы нет, чтобы не создавать одинаковые, для этого введи ключевое слово в поиске<br />';
      echo '<a href="search.php?' . SID . '">Поиск по форуму</a><br />';
      echo 'И если после этого вы уверены, что ваша тема будет интересна другим пользователям, то можете ее создать<br /><br />';
    } else {
      show_error('Разделы форума еще не созданы!');
    } 
  } else {
    show_login('Вы не авторизованы, для создания новой темы, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?fid=' . $fid . '&amp;' . SID . '">Вернуться</a><br />';
  break;
# ###########################################################################################
# #                               Подготовка к созданию темы                               ##
# ###########################################################################################
case "add":

  $uid = check($_GET['uid']);
  $fid = abs(intval($_POST['fid']));
  $title = check($_POST['title']);
  $msg = check($_POST['msg']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if (utf_strlen($title) >= 5 && utf_strlen($title) < 50) {
        if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 3000) {
          $queryforum = DB :: $dbh -> query("SELECT * FROM `forums` WHERE `forums_id`=? LIMIT 1;", array($fid));
          $forums = $queryforum -> fetch();

          if (!empty($forums)) {
            if (is_quarantine($log)) {
              if (is_flood($log)) {
                $msg = no_br($msg);
                $msg = antimat($msg);
                $msg = smiles($msg);

                DB :: $dbh -> query("UPDATE `users` SET `users_allforum`=`users_allforum`+1, `users_point`=`users_point`+1, `users_money`=`users_money`+5 WHERE `users_login`=?", array($log));

                DB :: $dbh -> query("INSERT INTO `topics` (`topics_forums_id`, `topics_title`, `topics_author`, `topics_posts`, `topics_last_user`, `topics_last_time`) VALUES (?, ?, ?, ?, ?, ?);", array($fid, $title, $log, 1, $log, SITETIME));

                $lastid = DB :: $dbh -> lastInsertId();

                DB :: $dbh -> query("INSERT INTO `posts` (`posts_topics_id`, `posts_forums_id`, `posts_user`, `posts_text`, `posts_time`, `posts_ip`, `posts_brow`) VALUES (?, ?, ?, ?, ?, ?, ?);", array($lastid, $fid, $log, $msg, SITETIME, $ip, $brow));

                DB :: $dbh -> query("UPDATE `forums` SET `forums_topics`=`forums_topics`+1, `forums_posts`=`forums_posts`+1, `forums_last_id`=?, `forums_last_themes`=?, `forums_last_user`=?, `forums_last_time`=? WHERE `forums_id`=?", array($lastid, $title, $log, SITETIME, $fid));
                // Обновление родительского форума
                if ($forums['forums_parent'] > 0) {
                  DB :: $dbh -> query("UPDATE `forums` SET `forums_last_id`=?, `forums_last_themes`=?, `forums_last_user`=?, `forums_last_time`=? WHERE `forums_id`=?", array($lastid, $title, $log, SITETIME, $forums['forums_parent']));
                } 

                $_SESSION['note'] = 'Новая тема успешно добавлена!';
                header ("Location: topic.php?tid=$lastid&" . SID);
                exit;
              } else {
                show_error('Антифлуд! Разрешается отправлять сообщения раз в ' . flood_period() . ' секунд!');
              } 
            } else {
              show_error('Карантин! Вы не можете писать в течении ' . round($config['karantin'] / 3600) . ' часов!');
            } 
          } else {
            show_error('Ошибка! Раздела для новой темы не существует!');
          } 
        } else {
          show_error('Ошибка! Слишком длинное или короткое сообщение!');
        } 
      } else {
        show_error('Ошибка! Слишком длинный или короткий заголовок темы!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, для создания новой темы, необходимо');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?fid=' . $fid . '&amp;' . SID . '">К темам</a><br />';
  break;

default:
  header("location: index.php?" . SID);
  exit;
  endswitch;

  echo '<img src="../images/img/reload.gif" alt="image" /> <a href="index.php?' . SID . '">К форумам</a><br />';
  echo '<img src="../images/img/homepage.gif" alt="image" /> <a href="../index.php?' . SID . '">На главную</a>';

  include_once ('../themes/' . $config['themes'] . '/foot.php');

  ?>